ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.38
Committed: Sun Sep 2 15:33:16 2012 UTC (11 years, 7 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.37: +9 -7 lines
Log Message:
Fixes to reciprocity for tensor tree representation

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.37 2012/06/14 22:42:21 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my @savedARGV = @ARGV;
17 my $tensortree = 0;
18 my $ttlog2 = 4;
19 my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 my $mgfin = 0;
22 my $geout = 1;
23 my $nproc = 1;
24 my $doforw = 0;
25 my $doback = 1;
26 my $pctcull = 90;
27 my $gunit = "Meter";
28 my @dim;
29 # Get options
30 while ($#ARGV >= 0) {
31 if ("$ARGV[0]" =~ /^[-+]m/) {
32 $mgfin = ("$ARGV[0]" =~ /^\+/);
33 } elsif ("$ARGV[0]" eq "-r") {
34 $rtargs = "$rtargs $ARGV[1]";
35 shift @ARGV;
36 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37 $geout = ("$ARGV[0]" =~ /^\+/);
38 $gunit = $ARGV[1];
39 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 }
42 shift @ARGV;
43 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44 $doforw = ("$ARGV[0]" =~ /^\+/);
45 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46 $doback = ("$ARGV[0]" =~ /^\+/);
47 } elsif ("$ARGV[0]" eq "-t") {
48 # Use value < 0 for rttree_reduce bypass
49 $pctcull = $ARGV[1];
50 shift @ARGV;
51 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 $tensortree = substr($ARGV[0], 2, 1);
53 $ttlog2 = $ARGV[1];
54 shift @ARGV;
55 } elsif ("$ARGV[0]" eq "-c") {
56 $nsamp = $ARGV[1];
57 shift @ARGV;
58 } elsif ("$ARGV[0]" eq "-n") {
59 $nproc = $ARGV[1];
60 shift @ARGV;
61 } elsif ("$ARGV[0]" =~ /^-d/) {
62 userror() if ($#ARGV < 6);
63 @dim = @ARGV[1..6];
64 shift @ARGV for (1..6);
65 } elsif ("$ARGV[0]" =~ /^[-+]./) {
66 userror();
67 } else {
68 last;
69 }
70 shift @ARGV;
71 }
72 # Check that we're actually being asked to do something
73 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74 # Get scene description and dimensions
75 my $radscn = "$td/device.rad";
76 my $mgfscn = "$td/device.mgf";
77 my $octree = "$td/device.oct";
78 if ( $mgfin ) {
79 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
80 die "Could not load MGF input\n" if ( $? );
81 system "mgf2rad $mgfscn > $radscn";
82 } else {
83 system "xform -e @ARGV > $radscn";
84 die "Could not load Radiance input\n" if ( $? );
85 system "rad2mgf $radscn > $mgfscn" if ( $geout );
86 }
87 if ($#dim != 5) {
88 @dim = split ' ', `getbbox -h $radscn`;
89 }
90 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
91 # Add receiver surfaces (rectangular)
92 my $fmodnm="receiver_face";
93 my $bmodnm="receiver_behind";
94 open(RADSCN, ">> $radscn");
95 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99 close RADSCN;
100 # Generate octree
101 system "oconv -w $radscn > $octree";
102 die "Could not compile scene\n" if ( $? );
103 # Output XML prologue
104 print
105 '<?xml version="1.0" encoding="UTF-8"?>
106 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 ';
108 print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 print
110 '<WindowElementType>System</WindowElementType>
111 <Optical>
112 <Layer>
113 <Material>
114 <Name>Name</Name>
115 <Manufacturer>Manufacturer</Manufacturer>
116 ';
117 printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
119 printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
120 print "\t\t<DeviceType>Integral</DeviceType>\n";
121 # Output MGF description if requested
122 if ( $geout ) {
123 print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
124 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
125 open(MGFSCN, "< $mgfscn");
126 while (<MGFSCN>) { print $_; }
127 close MGFSCN;
128 print "xf\n";
129 print "\t\t</Geometry>\n";
130 }
131 print " </Material>\n";
132 # Set up surface sampling
133 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
134 my $ny = int($nsamp/$nx + .5);
135 $nsamp = $nx * $ny;
136 my $ns = 2**$ttlog2;
137 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
138 # Create data segments (all the work happens here)
139 if ( $tensortree ) {
140 do_tree_bsdf();
141 } else {
142 do_matrix_bsdf();
143 }
144 # Output XML epilogue
145 print
146 '</Layer>
147 </Optical>
148 </WindowElement>
149 ';
150 # Clean up temporary files and exit
151 exec("rm -rf $td");
152
153 #-------------- End of main program segment --------------#
154
155 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
156 sub do_tree_bsdf {
157 # Shirley-Chiu mapping from unit square to disk
158 $sq2disk = '
159 in_square_a = 2*in_square_x - 1;
160 in_square_b = 2*in_square_y - 1;
161 in_square_rgn = if(in_square_a + in_square_b,
162 if(in_square_a - in_square_b, 1, 2),
163 if(in_square_b - in_square_a, 3, 4));
164 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
165 -in_square_a, -in_square_b);
166 out_disk_phi = PI/4 * select(in_square_rgn,
167 in_square_b/in_square_a,
168 2 - in_square_a/in_square_b,
169 4 + in_square_b/in_square_a,
170 if(in_square_b*in_square_b,
171 6 - in_square_a/in_square_b, 0));
172 Dx = out_disk_r*cos(out_disk_phi);
173 Dy = out_disk_r*sin(out_disk_phi);
174 Dz = sqrt(1 - out_disk_r*out_disk_r);
175 ';
176 # Shirley-Chiu mapping from unit disk to square
177 $disk2sq = '
178 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
179 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
180 in_disk_phi = norm_radians(atan2(Dy, Dx));
181 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
182 out_square_a = select(in_disk_rgn,
183 in_disk_r,
184 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
185 -in_disk_r,
186 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
187 out_square_b = select(in_disk_rgn,
188 in_disk_phi*in_disk_r/(PI/4),
189 in_disk_r,
190 (PI - in_disk_phi)*in_disk_r/(PI/4),
191 -in_disk_r);
192 out_square_x = (out_square_a + 1)/2;
193 out_square_y = (out_square_b + 1)/2;
194 ';
195 # Announce ourselves in XML output
196 print "\t<DataDefinition>\n";
197 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198 print "\t</DataDefinition>\n";
199
200 # Start rcontrib processes for compute each side
201 do_tree_rtcontrib(0) if ( $doback );
202 do_tree_rtcontrib(1) if ( $doforw );
203
204 } # end of sub do_tree_bsdf()
205
206 # Run rcontrib process to generate tensor tree samples
207 sub do_tree_rtcontrib {
208 my $forw = shift;
209 my $matargs = "-m $bmodnm";
210 if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
211 my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212 "-e '$disk2sq' -bn '$ns*$ns' " .
213 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 "-o $td/%s.flt $matargs $octree";
215 if ( $tensortree == 3 ) {
216 # Isotropic BSDF
217 my $ns2 = $ns / 2;
218 $cmd = "cnt $ns2 $ny $nx " .
219 "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
220 "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
221 "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
222 "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
223 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
224 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
225 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
226 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
227 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
228 "| $cmd";
229 } else {
230 # Anisotropic BSDF
231 # Sample area vertically to improve load balance, since
232 # shading systems usually have bilateral symmetry (L-R)
233 $cmd = "cnt $ns $ns $ny $nx " .
234 "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
235 "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
236 "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 "-e 'in_square_x=(\$1+r1)/$ns' " .
239 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
242 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
243 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
244 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
245 "| $cmd";
246 }
247 # print STDERR "Starting: $cmd\n";
248 system "$cmd" || die "Failure running rcontrib";
249 ttree_out($forw);
250 } # end of do_tree_rtcontrib()
251
252 # Simplify and output tensor tree results
253 sub ttree_out {
254 my $forw = shift;
255 my $side = ("Back","Front")[$forw];
256 my $cmd;
257 # Only output one transmitted anisotropic distribution, preferring backwards
258 if ( !$forw || !$doback || $tensortree==3 ) {
259 print
260 ' <WavelengthData>
261 <LayerNumber>System</LayerNumber>
262 <Wavelength unit="Integral">Visible</Wavelength>
263 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
264 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
265 <WavelengthDataBlock>
266 ';
267 print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
268 print
269 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
270 <ScatteringDataType>BTDF</ScatteringDataType>
271 <ScatteringData>
272 ';
273 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
274 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
275 if ($pctcull >= 0) {
276 $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
277 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
278 system "$cmd" || die "Failure running rttree_reduce";
279 } else {
280 $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
281 print "{\n";
282 system "$cmd" || die "Failure running rcalc";
283 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
284 print "0\n";
285 }
286 print "}\n";
287 }
288 print
289 ' </ScatteringData>
290 </WavelengthDataBlock>
291 </WavelengthData>
292 ';
293 }
294 # Output reflection
295 print
296 ' <WavelengthData>
297 <LayerNumber>System</LayerNumber>
298 <Wavelength unit="Integral">Visible</Wavelength>
299 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
300 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
301 <WavelengthDataBlock>
302 ';
303 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
304 print
305 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
306 <ScatteringDataType>BRDF</ScatteringDataType>
307 <ScatteringData>
308 ';
309 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
310 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
311 if ($pctcull >= 0) {
312 $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
313 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
314 system "$cmd" || die "Failure running rttree_reduce";
315 } else {
316 $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
317 print "{\n";
318 system "$cmd" || die "Failure running rcalc";
319 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
320 print "0\n";
321 }
322 print "}\n";
323 }
324 print
325 ' </ScatteringData>
326 </WavelengthDataBlock>
327 </WavelengthData>
328 ';
329 } # end of ttree_out()
330
331 #------------- End of do_tree_bsdf() & subroutines -------------#
332
333 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
334 sub do_matrix_bsdf {
335 # Set up sampling of portal
336 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
337 $tcal = '
338 DEGREE : PI/180;
339 sq(x) : x*x;
340 Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
341 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
342 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
343 Kmax : Kaccum(Knaz(0));
344 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
345 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
346 Kcol = Kbin - Kaccum(Krow-1);
347 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
348 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
349 sin_kpol = sin(Kpol);
350 Dx = cos(Kazi)*sin_kpol;
351 Dy = sin(Kazi)*sin_kpol;
352 Dz = sqrt(1 - sin_kpol*sin_kpol);
353 KprojOmega = PI * if(Kbin-.5,
354 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
355 1 - sq(cos(Kpola(1)*DEGREE)));
356 ';
357 # Compute Klems bin from exiting ray direction (forward or backward)
358 $kcal = '
359 DEGREE : PI/180;
360 abs(x) : if(x, x, -x);
361 Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
362 posangle(a) : if(-a, a + 2*PI, a);
363 Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
364 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
365 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
366 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
367 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
368 if(pol-kpola(r), kfindrow(r+1, pol), r) );
369 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
370 kbin2(pol,azi) = select(kfindrow(1, pol),
371 kazn(azi,360/knaz(1)),
372 kaccum(1) + kazn(azi,360/knaz(2)),
373 kaccum(2) + kazn(azi,360/knaz(3)),
374 kaccum(3) + kazn(azi,360/knaz(4)),
375 kaccum(4) + kazn(azi,360/knaz(5)),
376 kaccum(5) + kazn(azi,360/knaz(6)),
377 kaccum(6) + kazn(azi,360/knaz(7)),
378 kaccum(7) + kazn(azi,360/knaz(8)),
379 kaccum(8) + kazn(azi,360/knaz(9))
380 );
381 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
382 ';
383 my $ndiv = 145;
384 # Compute scattering data using rcontrib
385 my @tfarr;
386 my @rfarr;
387 my @tbarr;
388 my @rbarr;
389 my $cmd;
390 my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
391 "-e '$kcal' -b kbin -bn $ndiv " .
392 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
393 my $rccmd = "rcalc -e '$tcal' " .
394 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
395 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
396 if ( $doforw ) {
397 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
398 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
399 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
400 "-e 'zp:$dim[4]' " .
401 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
402 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
403 "| $rtcmd";
404 system "$cmd" || die "Failure running: $cmd\n";
405 @tfarr = `$rccmd $td/$fmodnm.flt`;
406 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
407 @rfarr = `$rccmd $td/$bmodnm.flt`;
408 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
409 }
410 if ( $doback ) {
411 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
412 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
413 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
414 "-e 'zp:$dim[5]' " .
415 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
416 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
417 "| $rtcmd";
418 system "$cmd" || die "Failure running: $cmd\n";
419 @tbarr = `$rccmd $td/$bmodnm.flt`;
420 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
421 chomp(@tbarr);
422 @rbarr = `$rccmd $td/$fmodnm.flt`;
423 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
424 chomp(@rbarr);
425 }
426 # Output angle basis
427 print
428 ' <DataDefinition>
429 <IncidentDataStructure>Columns</IncidentDataStructure>
430 <AngleBasis>
431 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
432 <AngleBasisBlock>
433 <Theta>0</Theta>
434 <nPhis>1</nPhis>
435 <ThetaBounds>
436 <LowerTheta>0</LowerTheta>
437 <UpperTheta>5</UpperTheta>
438 </ThetaBounds>
439 </AngleBasisBlock>
440 <AngleBasisBlock>
441 <Theta>10</Theta>
442 <nPhis>8</nPhis>
443 <ThetaBounds>
444 <LowerTheta>5</LowerTheta>
445 <UpperTheta>15</UpperTheta>
446 </ThetaBounds>
447 </AngleBasisBlock>
448 <AngleBasisBlock>
449 <Theta>20</Theta>
450 <nPhis>16</nPhis>
451 <ThetaBounds>
452 <LowerTheta>15</LowerTheta>
453 <UpperTheta>25</UpperTheta>
454 </ThetaBounds>
455 </AngleBasisBlock>
456 <AngleBasisBlock>
457 <Theta>30</Theta>
458 <nPhis>20</nPhis>
459 <ThetaBounds>
460 <LowerTheta>25</LowerTheta>
461 <UpperTheta>35</UpperTheta>
462 </ThetaBounds>
463 </AngleBasisBlock>
464 <AngleBasisBlock>
465 <Theta>40</Theta>
466 <nPhis>24</nPhis>
467 <ThetaBounds>
468 <LowerTheta>35</LowerTheta>
469 <UpperTheta>45</UpperTheta>
470 </ThetaBounds>
471 </AngleBasisBlock>
472 <AngleBasisBlock>
473 <Theta>50</Theta>
474 <nPhis>24</nPhis>
475 <ThetaBounds>
476 <LowerTheta>45</LowerTheta>
477 <UpperTheta>55</UpperTheta>
478 </ThetaBounds>
479 </AngleBasisBlock>
480 <AngleBasisBlock>
481 <Theta>60</Theta>
482 <nPhis>24</nPhis>
483 <ThetaBounds>
484 <LowerTheta>55</LowerTheta>
485 <UpperTheta>65</UpperTheta>
486 </ThetaBounds>
487 </AngleBasisBlock>
488 <AngleBasisBlock>
489 <Theta>70</Theta>
490 <nPhis>16</nPhis>
491 <ThetaBounds>
492 <LowerTheta>65</LowerTheta>
493 <UpperTheta>75</UpperTheta>
494 </ThetaBounds>
495 </AngleBasisBlock>
496 <AngleBasisBlock>
497 <Theta>82.5</Theta>
498 <nPhis>12</nPhis>
499 <ThetaBounds>
500 <LowerTheta>75</LowerTheta>
501 <UpperTheta>90</UpperTheta>
502 </ThetaBounds>
503 </AngleBasisBlock>
504 </AngleBasis>
505 </DataDefinition>
506 ';
507 if ( $doforw ) {
508 print
509 ' <WavelengthData>
510 <LayerNumber>System</LayerNumber>
511 <Wavelength unit="Integral">Visible</Wavelength>
512 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
513 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
514 <WavelengthDataBlock>
515 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
516 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
517 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
518 <ScatteringDataType>BTDF</ScatteringDataType>
519 <ScatteringData>
520 ';
521 # Output front transmission (transposed order)
522 for (my $od = 0; $od < $ndiv; $od++) {
523 for (my $id = 0; $id < $ndiv; $id++) {
524 print $tfarr[$ndiv*$id + $od], ",\n";
525 }
526 print "\n";
527 }
528 print
529 ' </ScatteringData>
530 </WavelengthDataBlock>
531 </WavelengthData>
532 <WavelengthData>
533 <LayerNumber>System</LayerNumber>
534 <Wavelength unit="Integral">Visible</Wavelength>
535 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
536 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
537 <WavelengthDataBlock>
538 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
539 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
540 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
541 <ScatteringDataType>BRDF</ScatteringDataType>
542 <ScatteringData>
543 ';
544 # Output front reflection (transposed order)
545 for (my $od = 0; $od < $ndiv; $od++) {
546 for (my $id = 0; $id < $ndiv; $id++) {
547 print $rfarr[$ndiv*$id + $od], ",\n";
548 }
549 print "\n";
550 }
551 print
552 ' </ScatteringData>
553 </WavelengthDataBlock>
554 </WavelengthData>
555 ';
556 }
557 if ( $doback ) {
558 print
559 ' <WavelengthData>
560 <LayerNumber>System</LayerNumber>
561 <Wavelength unit="Integral">Visible</Wavelength>
562 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
563 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
564 <WavelengthDataBlock>
565 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
566 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
567 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
568 <ScatteringDataType>BTDF</ScatteringDataType>
569 <ScatteringData>
570 ';
571 # Output back transmission (transposed order)
572 for (my $od = 0; $od < $ndiv; $od++) {
573 for (my $id = 0; $id < $ndiv; $id++) {
574 print $tbarr[$ndiv*$id + $od], ",\n";
575 }
576 print "\n";
577 }
578 print
579 ' </ScatteringData>
580 </WavelengthDataBlock>
581 </WavelengthData>
582 <WavelengthData>
583 <LayerNumber>System</LayerNumber>
584 <Wavelength unit="Integral">Visible</Wavelength>
585 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
586 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
587 <WavelengthDataBlock>
588 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
589 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
590 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
591 <ScatteringDataType>BRDF</ScatteringDataType>
592 <ScatteringData>
593 ';
594 # Output back reflection (transposed order)
595 for (my $od = 0; $od < $ndiv; $od++) {
596 for (my $id = 0; $id < $ndiv; $id++) {
597 print $rbarr[$ndiv*$id + $od], ",\n";
598 }
599 print "\n";
600 }
601 print
602 ' </ScatteringData>
603 </WavelengthDataBlock>
604 </WavelengthData>
605 ';
606 }
607 }
608 #------------- End of do_matrix_bsdf() --------------#